# generated by datamodel-codegen:
#   filename:  lookalike_media_data_room.json

from __future__ import annotations

from enum import Enum
from typing import Optional, Sequence, Union

from pydantic import BaseModel, Extra, Field, conint


class EnclaveSpecificationV01(BaseModel):
    attestationProtoBase64: str
    id: str
    workerProtocol: conint(ge=0)


class FormatType1(Enum):
    STRING = 'STRING'
    INTEGER = 'INTEGER'
    FLOAT = 'FLOAT'
    EMAIL = 'EMAIL'
    DATE_ISO8601 = 'DATE_ISO8601'
    PHONE_NUMBER_E164 = 'PHONE_NUMBER_E164'
    HASH_SHA256_HEX = 'HASH_SHA256_HEX'


class HashingAlgorithm1(Enum):
    SHA256_HEX = 'SHA256_HEX'


class LookalikeMediaDataRoomV0(BaseModel):
    advertiserEmails: Sequence[str]
    agencyEmails: Sequence[str]
    authenticationRootCertificatePem: str
    driverEnclaveSpecification: EnclaveSpecificationV01
    enableAuditLogRetrieval: bool
    enableDevComputations: bool
    enableDownloadByAdvertiser: bool
    enableDownloadByAgency: bool
    enableDownloadByPublisher: bool
    enableOverlapInsights: bool
    hashMatchingIdWith: Optional[Optional[HashingAlgorithm1]] = None
    id: str
    mainAdvertiserEmail: str
    mainPublisherEmail: str
    matchingIdFormat: FormatType1
    name: str
    observerEmails: Sequence[str]
    publisherEmails: Sequence[str]
    pythonEnclaveSpecification: EnclaveSpecificationV01


class LookalikeMediaDataRoomV1(LookalikeMediaDataRoomV0):
    pass


class LookalikeMediaDataRoomV2(LookalikeMediaDataRoomV0):
    pass


class LookalikeMediaDcrComputeV0(BaseModel):
    advertiserEmails: Sequence[str]
    agencyEmails: Sequence[str]
    authenticationRootCertificatePem: str
    driverEnclaveSpecification: EnclaveSpecificationV01
    hashMatchingIdWith: Optional[Optional[HashingAlgorithm1]] = None
    id: str
    mainAdvertiserEmail: str
    mainPublisherEmail: str
    matchingIdFormat: FormatType1
    name: str
    observerEmails: Sequence[str]
    publisherEmails: Sequence[str]
    pythonEnclaveSpecification: EnclaveSpecificationV01
    rateLimitPublishDataNumPerWindow: Optional[conint(ge=0)] = 10
    rateLimitPublishDataWindowSeconds: Optional[conint(ge=0)] = 604800


class Type6(Enum):
    SUPPORTED = 'SUPPORTED'


class RequirementFlagValueItem6(BaseModel):
    type: Type6


class Type7(Enum):
    DATASET = 'DATASET'


class RequirementFlagValueItem7(BaseModel):
    type: Type7


class Type8(Enum):
    PROPERTY = 'PROPERTY'


class RequirementFlagValueItem8(BaseModel):
    type: Type8
    value: str


class RequirementFlagValue(BaseModel):
    __root__: Union[
        RequirementFlagValueItem6, RequirementFlagValueItem7, RequirementFlagValueItem8
    ]


class LookalikeMediaDataRoomItem4(BaseModel):
    class Config:
        extra = Extra.forbid

    v0: LookalikeMediaDataRoomV0


class LookalikeMediaDataRoomItem5(BaseModel):
    class Config:
        extra = Extra.forbid

    v1: LookalikeMediaDataRoomV1


class LookalikeMediaDataRoomItem6(BaseModel):
    class Config:
        extra = Extra.forbid

    v2: LookalikeMediaDataRoomV2


class KnownOrUnknownRequirementFlagValue2(BaseModel):
    __root__: Optional[RequirementFlagValue]


class LookalikeMediaDcrComputeItem1(BaseModel):
    class Config:
        extra = Extra.forbid

    v0: LookalikeMediaDcrComputeV0


class LookalikeMediaDcrCompute1(BaseModel):
    __root__: LookalikeMediaDcrComputeItem1


class LookalikeMediaDcrComputeOrUnknown1(BaseModel):
    __root__: Optional[LookalikeMediaDcrCompute1]


class RequirementFlag2(BaseModel):
    details: KnownOrUnknownRequirementFlagValue2
    name: str


class Requirements(BaseModel):
    optional: Sequence[RequirementFlag2]
    required: Sequence[RequirementFlag2]


class LookalikeMediaDcrWrapper(BaseModel):
    compute: LookalikeMediaDcrComputeOrUnknown1
    consumes: Requirements
    features: Sequence[str]


class LookalikeMediaDataRoomItem7(BaseModel):
    class Config:
        extra = Extra.forbid

    v3: LookalikeMediaDcrWrapper


class LookalikeMediaDataRoom(BaseModel):
    __root__: Union[
        LookalikeMediaDataRoomItem4,
        LookalikeMediaDataRoomItem5,
        LookalikeMediaDataRoomItem6,
        LookalikeMediaDataRoomItem7,
    ] = Field(
        ...,
        description='The high-level representation of an LMDCR. Starting with version 4, an outer structure has been introduced that exposes the "features" supported by the LMDCR via string-based flags. This way, every version of DDC can extract these feature flags and inform the SDKs whether a particular function is supported by this LMDCR. In a similar way, the LMDCR exposes what datasets it needs as input from a DataLab such that we can check the compatibility between a DataLab and a LMDCR from any version of DDC/the SDKs.',
        title='LookalikeMediaDataRoom',
    )
