# generated by datamodel-codegen:
#   filename:  lookalike_media_request.json

from __future__ import annotations

from enum import Enum
from typing import Optional, Sequence, Union

from pydantic import BaseModel, Extra, Field, conint


class RetrieveDataRoom(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoomIdHex: str


class LookalikeMediaRequestItem1(BaseModel):
    class Config:
        extra = Extra.forbid

    retrieveDataRoom: RetrieveDataRoom


class PublishAdvertiserDataset(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoomIdHex: str
    datasetHashHex: str
    encryptionKeyHex: str
    scopeIdHex: str


class LookalikeMediaRequestItem2(BaseModel):
    class Config:
        extra = Extra.forbid

    publishAdvertiserDataset: PublishAdvertiserDataset


class PublishPublisherUsersDataset(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem3(BaseModel):
    class Config:
        extra = Extra.forbid

    publishPublisherUsersDataset: PublishPublisherUsersDataset


class UnpublishPublisherUsersDataset(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem4(BaseModel):
    class Config:
        extra = Extra.forbid

    unpublishPublisherUsersDataset: UnpublishPublisherUsersDataset


class UnpublishAdvertiserDataset(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem5(BaseModel):
    class Config:
        extra = Extra.forbid

    unpublishAdvertiserDataset: UnpublishAdvertiserDataset


class UnpublishDemographicsDataset(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem6(BaseModel):
    class Config:
        extra = Extra.forbid

    unpublishDemographicsDataset: UnpublishDemographicsDataset


class UnpublishEmbeddingsDataset(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem7(BaseModel):
    class Config:
        extra = Extra.forbid

    unpublishEmbeddingsDataset: UnpublishEmbeddingsDataset


class UnpublishSegmentsDataset(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem8(BaseModel):
    class Config:
        extra = Extra.forbid

    unpublishSegmentsDataset: UnpublishSegmentsDataset


class RetrievePublishedDatasets(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem9(BaseModel):
    class Config:
        extra = Extra.forbid

    retrievePublishedDatasets: RetrievePublishedDatasets


class CalculateOverlapBasic(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoomIdHex: str
    scopeIdHex: str


class LookalikeMediaRequestItem10(BaseModel):
    class Config:
        extra = Extra.forbid

    calculateOverlapBasic: CalculateOverlapBasic


class CalculateOverlapInsights(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem11(BaseModel):
    class Config:
        extra = Extra.forbid

    calculateOverlapInsights: CalculateOverlapInsights


class PublishDemographicsDataset(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem12(BaseModel):
    class Config:
        extra = Extra.forbid

    publishDemographicsDataset: PublishDemographicsDataset


class PublishSegmentsDataset(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem13(BaseModel):
    class Config:
        extra = Extra.forbid

    publishSegmentsDataset: PublishSegmentsDataset


class PublishEmbeddingsDataset(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem14(BaseModel):
    class Config:
        extra = Extra.forbid

    publishEmbeddingsDataset: PublishEmbeddingsDataset


class PublishActivatedAudiencesConfig(PublishAdvertiserDataset):
    pass


class LookalikeMediaRequestItem15(BaseModel):
    class Config:
        extra = Extra.forbid

    publishActivatedAudiencesConfig: PublishActivatedAudiencesConfig


class UnpublishActivatedAudiencesConfig(RetrieveDataRoom):
    pass


class LookalikeMediaRequestItem16(BaseModel):
    class Config:
        extra = Extra.forbid

    unpublishActivatedAudiencesConfig: UnpublishActivatedAudiencesConfig


class CalculateModelledAudienceInsights(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem17(BaseModel):
    class Config:
        extra = Extra.forbid

    calculateModelledAudienceInsights: CalculateModelledAudienceInsights


class CalculateModelledAudienceInsightsView(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem18(BaseModel):
    class Config:
        extra = Extra.forbid

    calculateModelledAudienceInsightsView: CalculateModelledAudienceInsightsView


class ComputeAudienceSizes(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem19(BaseModel):
    class Config:
        extra = Extra.forbid

    computeAudienceSizes: ComputeAudienceSizes


class ViewPublishedActivatedAudiences(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem21(BaseModel):
    class Config:
        extra = Extra.forbid

    viewPublishedActivatedAudiences: ViewPublishedActivatedAudiences


class ViewActivatedAudiences(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem22(BaseModel):
    class Config:
        extra = Extra.forbid

    viewActivatedAudiences: ViewActivatedAudiences


class IngestAudiencesReport(CalculateOverlapBasic):
    pass


class LookalikeMediaRequestItem23(BaseModel):
    class Config:
        extra = Extra.forbid

    ingestAudiencesReport: IngestAudiencesReport


class EnclaveSpecificationV0(BaseModel):
    attestationProtoBase64: str
    id: str
    workerProtocol: conint(ge=0)


class FormatType(Enum):
    STRING = 'STRING'
    INTEGER = 'INTEGER'
    FLOAT = 'FLOAT'
    EMAIL = 'EMAIL'
    DATE_ISO8601 = 'DATE_ISO8601'
    PHONE_NUMBER_E164 = 'PHONE_NUMBER_E164'
    HASH_SHA256_HEX = 'HASH_SHA256_HEX'


class HashingAlgorithm(Enum):
    SHA256_HEX = 'SHA256_HEX'


class LookalikeMediaDataRoomV0(BaseModel):
    advertiserEmails: Sequence[str]
    agencyEmails: Sequence[str]
    authenticationRootCertificatePem: str
    driverEnclaveSpecification: EnclaveSpecificationV0
    enableAuditLogRetrieval: bool
    enableDevComputations: bool
    enableDownloadByAdvertiser: bool
    enableDownloadByAgency: bool
    enableDownloadByPublisher: bool
    enableOverlapInsights: bool
    hashMatchingIdWith: Optional[Optional[HashingAlgorithm]] = None
    id: str
    mainAdvertiserEmail: str
    mainPublisherEmail: str
    matchingIdFormat: FormatType
    name: str
    observerEmails: Sequence[str]
    publisherEmails: Sequence[str]
    pythonEnclaveSpecification: EnclaveSpecificationV0


class LookalikeMediaDataRoomV1(LookalikeMediaDataRoomV0):
    pass


class LookalikeMediaDataRoomV2(LookalikeMediaDataRoomV0):
    pass


class LookalikeMediaDcrComputeV0(BaseModel):
    advertiserEmails: Sequence[str]
    agencyEmails: Sequence[str]
    authenticationRootCertificatePem: str
    driverEnclaveSpecification: EnclaveSpecificationV0
    hashMatchingIdWith: Optional[Optional[HashingAlgorithm]] = None
    id: str
    mainAdvertiserEmail: str
    mainPublisherEmail: str
    matchingIdFormat: FormatType
    name: str
    observerEmails: Sequence[str]
    publisherEmails: Sequence[str]
    pythonEnclaveSpecification: EnclaveSpecificationV0
    rateLimitPublishDataNumPerWindow: Optional[conint(ge=0)] = 10
    rateLimitPublishDataWindowSeconds: Optional[conint(ge=0)] = 604800


class RequestedAudiencePayload(BaseModel):
    class Config:
        extra = Extra.forbid

    audienceType: str
    reach: float


class Type(Enum):
    SUPPORTED = 'SUPPORTED'


class RequirementFlagValueItem(BaseModel):
    type: Type


class Type1(Enum):
    DATASET = 'DATASET'


class RequirementFlagValueItem1(BaseModel):
    type: Type1


class Type2(Enum):
    PROPERTY = 'PROPERTY'


class RequirementFlagValueItem2(BaseModel):
    type: Type2
    value: str


class RequirementFlagValue(BaseModel):
    __root__: Union[
        RequirementFlagValueItem, RequirementFlagValueItem1, RequirementFlagValueItem2
    ]


class GetLookalikeAudience(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoomIdHex: str
    requestedAudience: RequestedAudiencePayload
    scopeIdHex: str


class LookalikeMediaRequestItem20(BaseModel):
    class Config:
        extra = Extra.forbid

    getLookalikeAudience: GetLookalikeAudience


class KnownOrUnknownRequirementFlagValue(BaseModel):
    __root__: Optional[RequirementFlagValue]


class LookalikeMediaDataRoomItem(BaseModel):
    class Config:
        extra = Extra.forbid

    v0: LookalikeMediaDataRoomV0


class LookalikeMediaDataRoomItem1(BaseModel):
    class Config:
        extra = Extra.forbid

    v1: LookalikeMediaDataRoomV1


class LookalikeMediaDataRoomItem2(BaseModel):
    class Config:
        extra = Extra.forbid

    v2: LookalikeMediaDataRoomV2


class LookalikeMediaDcrComputeItem(BaseModel):
    class Config:
        extra = Extra.forbid

    v0: LookalikeMediaDcrComputeV0


class LookalikeMediaDcrCompute(BaseModel):
    __root__: LookalikeMediaDcrComputeItem


class LookalikeMediaDcrComputeOrUnknown(BaseModel):
    __root__: Optional[LookalikeMediaDcrCompute]


class RequirementFlag(BaseModel):
    details: KnownOrUnknownRequirementFlagValue
    name: str


class Requirements(BaseModel):
    optional: Sequence[RequirementFlag]
    required: Sequence[RequirementFlag]


class LookalikeMediaDcrWrapper(BaseModel):
    compute: LookalikeMediaDcrComputeOrUnknown
    consumes: Requirements
    features: Sequence[str]


class LookalikeMediaDataRoomItem3(BaseModel):
    class Config:
        extra = Extra.forbid

    v3: LookalikeMediaDcrWrapper


class LookalikeMediaDataRoom(BaseModel):
    __root__: Union[
        LookalikeMediaDataRoomItem,
        LookalikeMediaDataRoomItem1,
        LookalikeMediaDataRoomItem2,
        LookalikeMediaDataRoomItem3,
    ] = Field(
        ...,
        description='The high-level representation of an LMDCR. Starting with version 4, an outer structure has been introduced that exposes the "features" supported by the LMDCR via string-based flags. This way, every version of DDC can extract these feature flags and inform the SDKs whether a particular function is supported by this LMDCR. In a similar way, the LMDCR exposes what datasets it needs as input from a DataLab such that we can check the compatibility between a DataLab and a LMDCR from any version of DDC/the SDKs.',
    )


class PublishDataRoom(BaseModel):
    class Config:
        extra = Extra.forbid

    dataRoom: LookalikeMediaDataRoom
    requirePassword: bool
    showOrganizationLogo: bool


class LookalikeMediaRequestItem(BaseModel):
    class Config:
        extra = Extra.forbid

    publishDataRoom: PublishDataRoom


class LookalikeMediaRequest(BaseModel):
    __root__: Union[
        LookalikeMediaRequestItem,
        LookalikeMediaRequestItem1,
        LookalikeMediaRequestItem2,
        LookalikeMediaRequestItem3,
        LookalikeMediaRequestItem4,
        LookalikeMediaRequestItem5,
        LookalikeMediaRequestItem6,
        LookalikeMediaRequestItem7,
        LookalikeMediaRequestItem8,
        LookalikeMediaRequestItem9,
        LookalikeMediaRequestItem10,
        LookalikeMediaRequestItem11,
        LookalikeMediaRequestItem12,
        LookalikeMediaRequestItem13,
        LookalikeMediaRequestItem14,
        LookalikeMediaRequestItem15,
        LookalikeMediaRequestItem16,
        LookalikeMediaRequestItem17,
        LookalikeMediaRequestItem18,
        LookalikeMediaRequestItem19,
        LookalikeMediaRequestItem20,
        LookalikeMediaRequestItem21,
        LookalikeMediaRequestItem22,
        LookalikeMediaRequestItem23,
    ] = Field(
        ..., description='MediaRequest -> GcgRequest', title='LookalikeMediaRequest'
    )
